'use strict';

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var tmpPromise = require('tmp-promise');
var fsExtra = require('fs-extra');
var execa = _interopDefault(require('execa'));

class Terminal {
  async apply(flow) {
    const app = flow.children[0];

    const script = app.open(app);

    const { path, fd } = await tmpPromise.file({
      prefix: 'workflow-wm-terminal-',
      postfix: '.sh',
      mode: 0o755
    });

    await fsExtra.outputFile(path, script);
    await fsExtra.close(fd);

    await execa(path, null, {
      detached: true,
      shell: true,
      stdio: ['inherit', 'inherit', 'inherit']
    });
  }

  async screen() {
    return {
      left: 0,
      top: 0,
      width: 1024,
      height: 768
    };
  }
}

module.exports = Terminal;
